import { EventEmitter } from '@angular/core';
import * as common from 'schema-based-json-editor';
export declare class ArrayEditorComponent {
    schema: common.ArraySchema;
    initialValue: common.ValueType[];
    title?: string;
    updateValue: EventEmitter<common.ValidityValue<common.ValueType[] | undefined>>;
    theme: common.Theme;
    icon: common.Icon;
    locale: common.Locale;
    onDelete: EventEmitter<any>;
    readonly?: boolean;
    required?: boolean;
    hasDeleteButton: boolean;
    dragula?: common.Dragula;
    md?: any;
    hljs?: common.HLJS;
    forceHttps?: boolean;
    disableCollapse?: boolean;
    noSelect2?: boolean;
    minItemCountIfNeedFilter?: number;
    monacoEditor?: common.MonacoEditor;
    getReference: (name: string) => common.Schema | undefined;
    collapsed?: boolean | undefined;
    value?: common.ValueType[];
    errorMessage: string;
    buttonGroupStyleString: string;
    filter: string;
    private drakContainer;
    private renderSwitch;
    private drak?;
    private invalidIndexes;
    private readonly getValue;
    readonly filteredValues: {
        p: common.ValueType;
        i: number;
    }[];
    readonly showFilter: boolean;
    ngOnInit(): void;
    readonly isReadOnly: boolean | undefined;
    readonly hasDeleteButtonFunction: boolean;
    readonly hasAddButton: boolean;
    readonly titleToShow: string;
    readonly className: string;
    readonly options: {
        value: string | number;
        label: string | number;
    }[];
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    trackByFunction: (index: number, item: {
        p: common.ValueType;
        i: number;
    }) => number;
    trackByOptions: (index: number, item: {
        value: common.ValueType;
        label: string;
    }) => common.ValueType;
    collapseOrExpand: () => void;
    toggleOptional: () => void;
    addItem(): void;
    onDeleteFunction(i: number): void;
    onChange(i: number, { value, isValid }: common.ValidityValue<common.ValueType>): void;
    onFilterChange(e: {
        target: {
            value: string;
        };
    }): void;
    isChecked(value: any): boolean | undefined;
    onChangeCheckbox(value: any): void;
    onChangeSelect2(value: any): void;
    private validate;
}
