import { EventEmitter } from '@angular/core';
import * as common from 'schema-based-json-editor';
export * from 'schema-based-json-editor';
/**
 * @public
 */
export declare class JSONEditorComponent {
    schema: common.Schema;
    initialValue: common.ValueType;
    updateValue: EventEmitter<common.ValidityValue<common.ValueType>>;
    theme?: string;
    icon?: string;
    locale?: common.Locale;
    readonly?: boolean;
    dragula?: common.Dragula;
    markdownit?: any;
    hljs?: common.HLJS;
    forceHttps?: boolean;
    disableCollapse?: boolean;
    noSelect2?: boolean;
    minItemCountIfNeedFilter?: number;
    monacoEditor?: common.MonacoEditor;
    readonly themeObject: {
        card: string;
        row: string;
        errorRow: string;
        input: string;
        errorInput: string;
        textarea: string;
        errorTextarea: string;
        checkbox: string;
        radiobox: string;
        button: string;
        buttonGroup: string;
        title: string;
        description: string;
        select: string;
    };
    readonly localeObject: {
        button: {
            collapse: string;
            expand: string;
            add: string;
            delete: string;
        };
        error: {
            minLength: string;
            maxLength: string;
            pattern: string;
            minimum: string;
            maximum: string;
            largerThan: string;
            smallerThan: string;
            minItems: string;
            uniqueItems: string;
            multipleOf: string;
            minProperties: string;
            maxProperties: string;
        };
        info: {
            notExists: string;
            true: string;
            false: string;
            search: string;
        };
        markdownTipLocale: any;
        fileUploaderLocale: {
            dragAndDrop: string;
            selectFile: string;
            pasteFromClipboard: string;
        };
    };
    readonly iconObject: {
        isText: boolean;
        collapse: string;
        expand: string;
        add: string;
        delete: string;
    };
    md?: any;
    getReference: (name: string) => common.StringSchema | common.ObjectSchema | common.ArraySchema | common.NumberSchema | common.BooleanSchema | common.NullSchema | common.AnySchema | undefined;
    ngOnInit(): void;
}
