import * as tslib_1 from "tslib";
import { Component, Input, Output, EventEmitter } from '@angular/core';
import * as common from 'schema-based-json-editor';
export * from 'schema-based-json-editor';
import { indexTemplateHtml } from './variables';
/**
 * @public
 */
var JSONEditorComponent = /** @class */ (function () {
    function JSONEditorComponent() {
        var _this = this;
        this.updateValue = new EventEmitter();
        this.getReference = function (name) {
            if (_this.schema.definitions) {
                return _this.schema.definitions[name.substring('#/definitions/'.length)];
            }
            return undefined;
        };
    }
    Object.defineProperty(JSONEditorComponent.prototype, "themeObject", {
        get: function () {
            return common.getTheme(this.theme);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(JSONEditorComponent.prototype, "localeObject", {
        get: function () {
            return common.getLocale(this.locale);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(JSONEditorComponent.prototype, "iconObject", {
        get: function () {
            return common.getIcon(this.icon, this.localeObject);
        },
        enumerable: true,
        configurable: true
    });
    JSONEditorComponent.prototype.ngOnInit = function () {
        this.md = common.initializeMarkdown(this.markdownit, this.hljs, this.forceHttps);
    };
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Object)
    ], JSONEditorComponent.prototype, "schema", void 0);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Object)
    ], JSONEditorComponent.prototype, "initialValue", void 0);
    tslib_1.__decorate([
        Output(),
        tslib_1.__metadata("design:type", Object)
    ], JSONEditorComponent.prototype, "updateValue", void 0);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String)
    ], JSONEditorComponent.prototype, "theme", void 0);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String)
    ], JSONEditorComponent.prototype, "icon", void 0);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Object)
    ], JSONEditorComponent.prototype, "locale", void 0);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Boolean)
    ], JSONEditorComponent.prototype, "readonly", void 0);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Function)
    ], JSONEditorComponent.prototype, "dragula", void 0);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Object)
    ], JSONEditorComponent.prototype, "markdownit", void 0);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Object)
    ], JSONEditorComponent.prototype, "hljs", void 0);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Boolean)
    ], JSONEditorComponent.prototype, "forceHttps", void 0);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Boolean)
    ], JSONEditorComponent.prototype, "disableCollapse", void 0);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Boolean)
    ], JSONEditorComponent.prototype, "noSelect2", void 0);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number)
    ], JSONEditorComponent.prototype, "minItemCountIfNeedFilter", void 0);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Object)
    ], JSONEditorComponent.prototype, "monacoEditor", void 0);
    JSONEditorComponent = tslib_1.__decorate([
        Component({
            selector: 'json-editor',
            template: indexTemplateHtml
        })
    ], JSONEditorComponent);
    return JSONEditorComponent;
}());
export { JSONEditorComponent };
