import { EventEmitter } from '@angular/core';
import * as common from 'schema-based-json-editor';
export declare class ObjectEditorComponent {
    schema: common.ObjectSchema;
    initialValue: {
        [name: string]: common.ValueType;
    };
    title?: string;
    updateValue: EventEmitter<common.ValidityValue<{
        [name: string]: common.ValueType;
    } | undefined>>;
    theme: common.Theme;
    icon: common.Icon;
    locale: common.Locale;
    onDelete: EventEmitter<any>;
    readonly?: boolean;
    required?: boolean;
    hasDeleteButton: boolean;
    dragula?: common.Dragula;
    md?: any;
    hljs?: common.HLJS;
    forceHttps?: boolean;
    disableCollapse?: boolean;
    noSelect2?: boolean;
    minItemCountIfNeedFilter?: number;
    monacoEditor?: common.MonacoEditor;
    getReference: (name: string) => common.Schema | undefined;
    collapsed?: boolean | undefined;
    value?: {
        [name: string]: common.ValueType;
    };
    buttonGroupStyle: string;
    errorMessage: string;
    filter: string;
    private properties;
    private invalidProperties;
    ngOnInit(): void;
    isRequired(property: string): boolean | undefined;
    trackByFunction: (index: number, p: {
        property: string;
        schema: common.Schema;
    }) => string;
    collapseOrExpand: () => void;
    toggleOptional: () => void;
    onChange(property: string, { value, isValid }: common.ValidityValue<{
        [name: string]: common.ValueType;
    }>): void;
    onFilterChange(e: {
        target: {
            value: string;
        };
    }): void;
    private validate;
    readonly filteredProperties: {
        property: string;
        schema: common.Schema;
        propertyName: string;
    }[];
    readonly hasDeleteButtonFunction: boolean;
    readonly isReadOnly: boolean | undefined;
    readonly titleToShow: string;
    readonly showFilter: boolean;
    readonly className: string;
}
