import { EventEmitter } from '@angular/core';
import * as common from 'schema-based-json-editor';
export declare class StringEditorComponent {
    schema: common.StringSchema;
    initialValue: string;
    title?: string;
    updateValue: EventEmitter<common.ValidityValue<string | undefined>>;
    theme: common.Theme;
    icon: common.Icon;
    locale: common.Locale;
    onDelete: EventEmitter<any>;
    readonly?: boolean;
    required?: boolean;
    hasDeleteButton: boolean;
    dragula?: common.Dragula;
    md?: any;
    hljs?: common.HLJS;
    forceHttps?: boolean;
    noSelect2?: boolean;
    monacoEditor?: common.MonacoEditor;
    private monacoEditorRef;
    value?: string;
    errorMessage: string;
    buttonGroupStyle: string;
    collapsed: boolean;
    private monacoCodeEditor?;
    onChange(e: {
        target: {
            value: string;
        };
    }): void;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    readonly useTextArea: boolean | undefined;
    readonly useInput: boolean | undefined;
    readonly useSelect: boolean;
    readonly useSelect2Component: boolean;
    readonly useSelectComponent: boolean | undefined;
    readonly useRadioBoxComponent: boolean;
    private readonly canPreviewImage;
    private readonly canPreviewMarkdown;
    private readonly canPreviewCode;
    readonly canPreview: boolean | undefined;
    readonly getImageUrl: string | undefined;
    readonly getMarkdown: any;
    readonly getCode: string;
    readonly isReadOnly: boolean | undefined;
    readonly hasDeleteButtonFunction: boolean;
    readonly willPreviewImage: boolean | "" | undefined;
    readonly willPreviewMarkdown: boolean | "" | undefined;
    readonly willPreviewCode: boolean | "" | undefined;
    readonly titleToShow: string;
    readonly options: {
        value: string | number;
        label: string | number;
    }[];
    readonly canUpload: boolean;
    readonly className: string;
    updateSelection(value: string): void;
    trackByFunction: (index: number) => number;
    toggleOptional: () => void;
    collapseOrExpand: () => void;
    fileGot(file: File | Blob): void;
    private validate;
}
